import { ExternalTokenizer, LRParser } from '@lezer/lr';
import { parseMixed } from '@lezer/common';
import { htmlLanguage, html } from '@codemirror/lang-html';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';
import { ifIn, completeFromList, insertCompletionText, pickedCompletion } from '@codemirror/autocomplete';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const endcommentTagStart = 1,
  CommentText = 2,
  endrawTagStart = 3,
  RawText = 4;

function wordChar(code) {
    return code >= 65 && code <= 90 || code >= 97 && code <= 122;
}
function rawTokenizer(endTag, text, tagStart) {
    return new ExternalTokenizer(input => {
        let start = input.pos;
        for (;;) {
            let { next } = input;
            if (next == 123 /* Ch.BraceL */ && input.peek(1) == 37 /* Ch.Percent */) {
                let scan = 2;
                if (input.peek(scan) == 45 /* Ch.Dash */)
                    scan++;
                const tagStartLength = scan;
                for (;; scan++) {
                    let ch = input.peek(scan);
                    if (ch != 32 /* Ch.Space */ && ch != 9 /* Ch.Tab */)
                        break;
                }
                let word = "";
                for (;; scan++) {
                    let next = input.peek(scan);
                    if (!wordChar(next))
                        break;
                    word += String.fromCharCode(next);
                }
                if (word == endTag) {
                    if (input.pos > start)
                        break;
                    input.acceptToken(tagStart, tagStartLength);
                    break;
                }
            }
            else if (next < 0) {
                break;
            }
            input.advance();
        }
        if (input.pos > start) {
            input.acceptToken(text);
        }
    });
}
const raw = rawTokenizer("endraw", RawText, endrawTagStart);
const comment = rawTokenizer("endcomment", CommentText, endcommentTagStart);

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_identifier = {__proto__:null,true:326, false:326, empty:328, blank:328, forloop:328, nil:330, null:330, assign:340, block:342, cycle:344, increment:346, decrement:348, echo:350, include:352, with:356, render:358, layout:360, liquid:362, break:368, capture:370, endcapture:372, case:374, when:376, endcase:378, continue:380, for:382, in:384, reversed:148, offset:152, limit:156, endfor:392, if:394, elsif:396, else:398, endif:400, "#":402, tablerow:404, cols:190, endtablerow:408, unless:410, raw:412, endraw:414, endunless:418, comment:420, endcomment:422};
const parser = LRParser.deserialize({
  version: 14,
  states: "! WQVOSOOObQWO'#CbO|QWO'#CzO#ZOSO'#EkO#fOSO'#EnO#kOSO'#EsO#vOSO'#ExO$ROSO'#E|O$^OSO'#FRO$iOPO'#FUO$nOQO'#F]OOOO'#F{'#F{OOOO'#Fp'#FpOOOO'#Fa'#FaQVOSOOOOQO'#Cd'#CdO$sQWO'#FqObQWO'#CeOOQO'#Cl'#ClOOQO'#Cm'#CmOOQO'#Cn'#CnOOQO'#Ft'#FtObQWO'#CoOOQO'#Fr'#FrO%XQWO,58|OOQO'#C}'#C}O%^QWO'#C|OOQO'#DR'#DRO%cQWO'#DQOOQO'#DU'#DUO&PQWO'#DTOOQO'#DW'#DWObQWO'#DVOOQO'#DY'#DYObQWO'#DXOOQO'#D['#D[ObQWO'#DZOOQO'#D^'#D^ObQWO'#D]OOQO'#Da'#DaObQWO'#D`OOQO'#Dc'#DcObQWO'#DbOOQO'#De'#DeOOQO'#Di'#DiO%^QWO'#DhOOQO'#Dm'#DmObQWO'#DlOOQO'#Du'#DuO%^QWO'#DtOOQO'#EQ'#EQO&WQWO'#EPOOQO'#E]'#E]O%^QWO'#E[OOQO'#Ec'#EcO&bQWO'#EbOOQO'#Ee'#EeOOQO'#Ed'#EdOOQO'#Ei'#EiO&lQ`O'#EhO&wQWO'#DdO'PQWO,59fO'UQWO,5;WO'ZQWO,5;ZO'`QWO,5;`O'eQWO,5;eO'jQWO,5;iO'oQWO,5;nOOQO'#FX'#FXOOQO'#FW'#FWO'tQWO,5;qO'yQWO,5;xO(OQWO'#CzOOOO,5;V,5;VO#ZOSO,5;VO(VQWO'#EpOOOO,5;Y,5;YO(bOSO,5;YO(mOSO,5;YO(xQWO'#CzOOOO'#Gt'#GtOOOO'#Fl'#FlO#kOSO,5;_OOOO,5;_,5;_O)YOSO,5;_O)eQWO'#CzOOOO,5;d,5;dO)rOSO,5;dO)}OSO,5;dO#vOSO,5;dO*YQWO'#CzOOOO,5;h,5;hO*gOSO,5;hO*rOSO,5;hO$ROSO,5;hO*}QWO'#CzOOOO,5;m,5;mO+XOSO,5;mO$^OSO,5;mO+dOPO,5;pO+iOQO,5;wOOOO-E9_-E9_O+nQWO,59PObQWO,59PO+sQWO'#CqOOQO'#Fb'#FbO+xQWO,5<]O,WQWO,59PO,cQWO,59ZOOOO1G.h1G.hOOQO'#DO'#DOO,nQWO,59hOOQO'#DS'#DSOOQO,59l,59lO-UQWO'#CdO-]QWO,59oO-nQWO,59oO-sQWO'#CeO-{QWO,59qO.ZQWO,59sOOQO,59u,59uO.iQWO,59wO.}QWO,59zO/cQWO,59|OOQO,5:S,5:SO/wQWO,5:WO0VQWO,5:`O0[QWO,5:kO0VQWO,5:vO0jQWO,5:|OOQO'#Fk'#FkO0xQ`O,5;SOOQO'#Fg'#FgO3TQWO,5:OO3[QWO,5:OOOOO1G/Q1G/QOOOO1G0r1G0rOOOO1G0u1G0uOOOO1G0z1G0zOOOO1G1P1G1POOOO1G1T1G1TOOOO1G1Y1G1YOOOP1G1]1G1]OOOQ1G1d1G1dOOQO'#Dk'#DkOOQO'#Dj'#DjO3dQWO,5;XOOOO1G0q1G0qOOQO'#Do'#DoObQWO'#DnOOQO'#Dq'#DqOOQO'#Dp'#DpOOQO'#EU'#EUOOQO'#ET'#ETO3iQWO,5;[O3nQWO,5;]O3sQWO,5;^O3xQWO'#CzOOOO1G0t1G0tO(bOSO1G0tO4PQWO'#CzO(bOSO1G0tO(mOSO1G0tOOQO'#Dg'#DgOOQO'#Df'#DfOOQO'#Ds'#DsOOQO'#Dr'#DrOOQO'#EO'#EOOOQO'#D}'#D}O4ZQWO,5;aO4`QWO,5;bO4eQWO,5;cOOOO-E9j-E9jOOOO1G0y1G0yO)YOSO1G0yO4jQWO'#CzO)YOSO1G0yOOQO'#ES'#ESO4wQWO'#EROOQO'#EW'#EWOOQO'#EV'#EVO5RQWO,5;fO5WQWO,5;gO)kQWO'#CzOOOO1G1O1G1OO)rOSO1G1OO)hQWO'#CzO)rOSO1G1OO)}OSO1G1OO)}OSO1G1OOOQO'#FQ'#FQOOQO'#FP'#FPO5]QWO,5;jO*`QWO'#CzOOOO1G1S1G1SO*gOSO1G1SO*]QWO'#CzO*gOSO1G1SO*rOSO1G1SO*rOSO1G1SOOQO'#Ea'#EaOOQO'#E`'#E`O5bQWO,5;oO+QQWO'#CzOOOO1G1X1G1XO+XOSO1G1XO+XOSO1G1XO5gQWO'#FYOOOO1G1[1G1[O3OQWO'#F_OOOO1G1c1G1cOOQO'#Cg'#CgOOQO1G.k1G.kO5lQWO1G.kOOQO'#Cr'#CrO5wQWO,59]OOQO-E9`-E9`ObQWO1G.uObQWO1G/SObQWO'#FdO6YQWO1G/ZObQWO1G/ZOOQO'#Cw'#CwO6eQWO'#CvOOQO'#D_'#D_O6jQWO'#GTOOQO'#GT'#GTO6qQWO1G/cO6|QWO1G/fO7XQWO1G/hOOQO'#Dv'#DvObQWO1G/zObQWO1G0bOOQO-E9i-E9iOOQO-E9e-E9eOOQO'#EY'#EYO7dQ`O'#EXOOQO'#Eg'#EgOOQO'#Ef'#EfOOQO'#GZ'#GZOOQO,5<Q,5<QO7oQWO1G/jOOQO-E9d-E9dOOOO1G0s1G0sO7vQWO,5:YOOOO1G0v1G0vOOOO1G0w1G0wOOOO1G0x1G0xOOOO7+&`7+&`O(bOSO7+&`O(bOSO7+&`OOOO1G0{1G0{OOOO1G0|1G0|OOOO1G0}1G0}P8UQWO'#CzO)YOSO7+&eOOOO7+&e7+&eO8`QWO,5:mOOOO1G1Q1G1QOOOO1G1R1G1ROOOO7+&j7+&jO)rOSO7+&jO)rOSO7+&jO)}OSO7+&jOOOO1G1U1G1UOOOO7+&n7+&nO*gOSO7+&nO*gOSO7+&nO*rOSO7+&nOOOO1G1Z1G1ZOOOO7+&s7+&sO+XOSO7+&sOOQO'#F['#F[OOQO'#FZ'#FZO8nQWO,5;tO8sQWO,5;yOOQO7+$V7+$VO8xQWO1G.wO9PQWO7+$aOOQO7+$n7+$nO9[QWO,5<OOOQO-E9b-E9bO9mQWO7+$uObQWO,59bO:OQWO,5<oObQWO,5<oO:aQWO'#FeO:iQWO7+$}O:tQWO7+%QO;PQWO7+%SO;mQWO7+%fO;zQWO7+%|OOQO,5:s,5:sP1TQWO'#FgOOOO<<Iz<<IzO(bOSO<<IzOOOO<<JP<<JPOOOO<<JU<<JUO)rOSO<<JUO)rOSO<<JUOOOO<<JY<<JYO*gOSO<<JYO*gOSO<<JYOOOO<<J_<<J_OOOO1G1`1G1`OOOO1G1e1G1eO<XQWO'#CdO<fQWO'#CuOOQO'#Cu'#CuO<}QWO'#CtOOQO7+$c7+$cOOQO<<G{<<G{O=`QWO<<HaO=kQWO1G.|O>`QWO1G2ZOOQO,5<P,5<POOQO-E9c-E9cO>qQWO'#GgOOQO'#Dw'#DwOOQO'#Dy'#DyO?PQWO'#GeOOQO'#D{'#D{O?UQWO'#GfOOQO'#Fh'#FhO?ZQWO<<IQOOQO'#Gg'#GgOOQO'#Fi'#FiO?dQWO<<IQO?oQWO'#FjOOQO'#E^'#E^O@WQWO'#GoOOQO'#Fj'#FjO@]QWO<<IhOOOOAN?fAN?fOOOOAN?pAN?pO)rOSOAN?pOOOOAN?tAN?tO*gOSOAN?tO8xQWO'#FcO@qQWO,59`ObQWO,5=PObQWO,5=QOOQO-E9f-E9fOASQWOAN>lOOQO-E9g-E9gObQWO,5=ZOOQO-E9h-E9hOOOOG25[G25[OOOOG25`G25`OOQO,5;},5;}OOQO-E9a-E9aOA_QWO1G2kOA|QWO1G2lOBkQWO1G2u",
  stateData: "Ch~O$cOS~OVPOoQO$S[O~O[aO^eO_eO$g_O$ibO$jcO$kdO$lfO~O$g![O$piO$qkO$rmO$soO$tqO$usO$vuO$ywO$zyO${{O%P|O%R!OO%V!QO%]!SO%b!UO%e!WO%f!YO%j!fO~OVPOo!jO$S[O~Oo!mO~OVPOo!qO$S[O~OVPOo!wO$S[O~OVPOo!|O$S[O~OVPOo#RO$S[O~OQ#VO~OS#WO~OY#YO[#ZO$n#[Om$eX#^$eX$|$eX~Om#aO~O$g#bO~O$g#dO~O[aO^eO_eO$ibO$jcO$kdO$lfO~O$g#fO~P%hO#^!sX$|!sX~PbO#^#UX$|#UX~PbO!}#vO#^#[X$|#[X~O$|#xO#^!WX~O#^#{O~O#^#|O~O#^#}O~O#^$OO~O#^$PO~O#^$QO~O#^$RO~O#^$SO~O#^$TO~O%Q$UO~P|O%S$YO%T$[O%_$^O~OVPOo$cO$S[O~OVPOo$fO$S[O~O%O$iO%U$kO%[$mO%_$^O~P|OVPOo$uO$S[O~O%^$wO%_$^O%`$yO~P|OVPOo$}O$S[O~OVPOo%QO$S[O~O%^$wO%_$^O%i%UO~P|OVPOo%XO$S[O~OVPOo%[O$S[O~O%_$^O%d%`O~P|OVPOo%cO$S[O~OP%gO~OR%iO~O$g%kO~O$g%nO~O$n#[Om$ea#^$ea$|$ea~OY#YO[#ZO]%lO~OY#YO[#ZOd%qO~Os%rO~OYWX[WXlWX#^WX$|WX~OgvX~P,sOY#YO[#ZOl%sO#^wa$|wa~Og%uO~OY#YO[#ZO~OY$fX[$fX#^ya$|ya~OY$fX[$fX#^{a$|{a~OY#YO[#ZO$g%vO$x%xO#^!Pa$|!Pa~OY#YO[#ZO$g%vO$x%xO#^!Sa$|!Sa~OY#YO[#ZO$g%vO$x%xO#^!Ua$|!Ua~OY#YO[#ZO#^!`a$|!`a~O%W&OO~OY#YO[#ZO#^!sa$|!sa~OY#YO[#ZO#^#Ua$|#Ua~O!}#vO#^#[a$|#[a~O$g![O$piO$qkO$rmO$soO$tqO$usO$vuO$ywO$zyO$|#xO%O$iO%P|O%Q$UO%R!OO%S$YO%T$[O%U$kO%V!QO%[$mO%]!SO%^$wO%_$^O%`$yO%a&TO%b!UO%d%`O%e!WO%f!YO%g&VO~O#^!Wa~P1TO$|#xO#^!Wa~O#^&]O~O#^&_O~O#^&`O~O#^&aO~O%T$[O~P|O%T$[O%_$^O~P|O#^&eO~O#^&fO~O#^&gO~O%O$iO%U$kO%[$mO~P|O#^!uX$|!uX~PbO#^&lO~O#^&mO~O#^&rO~O#^&wO~O%k&zO~OY#YO[#ZO]'OO~Og'POmea$nea#^ea$|ea~Ol%sO#^wi$|wi~Og'VO~Og'XO~PbOl'YO#^!Pi$|!Pi~Ol'YO#^!Si$|!Si~Ol'YO#^!Ui$|!Ui~O!}'`O#^!{X$|!{X~O#^!Wi~P1TOY#YO[#ZO#^!ba$|!ba~O%O$iO%U$kO~P|OY#YO[#ZO#^!ua$|!ua~O#^'lO~O#^'mO~O$g'nO~P%hOY#YO[#ZO$m'sO~OY#YO[#ZOl$Wa#^$Wa$|$Wa~OY#YO[#ZOl%sO#^wq$|wq~OY#YO[#ZOl$wa#^$wa$|$wa~O$g%vO$x%xO~Ol'YO#^!Pq$|!Pq~Ol'YO#^!Sq$|!Sq~Ol'YO#^!Uq$|!Uq~OY#YO[#ZO!n'{O!p'}O$g%vO~O!l'zO#^!hq$|!hq~P;[O#R(VO#^#Oq$|#Oq~P;[OgkXmWX$nWX~P,sOY#YO[#ZOliXmiX$niX#^iX$|iX~Ol(`OmhX$nhX#^hX$|hX~Ol%sO#^wy$|wy~OY#YO[#ZOlji#^jimji$nji$gji!nji!pji#Rji$|ji~OY#YO[#ZOl$wi#^$wi$|$wi~Og'VO#^%ZX$g%ZX$|%ZX~Og(bO~Og(cO~O!l'zO!n'{O!p'}O$g%vO#^!hy$|!hy~Og'VO!n$^X!p$^X#R$^X#^$^X$g$^X$|$^X~Og(gO~O!n'{O!p'}O#R(VO$g%vO#^#Oy$|#Oy~Ol(`Omha$nha#^ha$|ha~O$g%vO#^!h!R$|!h!R~OY#YO[#ZO!l%Xi!n%Xi!p%Xi#^%Xi$g%Xi#R%Xi$|%Xi~OY#YO[#ZO!l%Yi!n%Yi!p%Yi#^%Yi$g%Yi#R%Yi$|%Yi~OY#YO[#ZO!n%ci!p%ci#R%ci#^%ci$g%ci$|%ci~OoV#^m^_$g$cdsgY[]!}$c~",
  goto: "!%Y%iPPPPPP%jP&r&rP'hPPPP'k'k'k(]P(})RP)U)X)_)sPP*VP+_+u,ZP+_,g,{+_-R+_-g+_-{+_.a+_.u/Z+_/a+_/u0Z0l0}1X1a1w2]2e2k3R3g3o3u4P4X4c4k5R5g5mP5qP5wP5}6W6_6u7Z7d7k7z8X8c+p8kP8p9W9lP9p9y:Q:h:|;d;x<Q+_<WP*V<l=t*V=z?S?V@Y*V@mAuAuA}*VB]CeCq*VD]EeFPFU*VFZGc*VGqHyI[ImIpIs*VIvKOPKRMTMZMaMkMyNPN[NbNlNrNxPPP! W!!b!!kP(]PPPPPP%jPPPPPPP!$aPPPPP!$mPPPPPPPPP!$r!$r!$zPPPPPPP)oPPPP!%Q#][ORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_!YgPafntvxz!P!T!X#Z$Z$x%q%r%s%u%y&P&Q'P'V'X(`(b(c(gQ#jpR#krR%l#Y!_ePafnprtvxz!P!T!X#Z$Z$x%q%r%s%u%y&P&Q'P'V'X(`(b(c(g!_gPafnprtvxz!P!T!X#Z$Z$x%q%r%s%u%y&P&Q'P'V'X(`(b(c(gT#]`#^R%o#[R'r'PQ'q'PR(k(`W%z#m#n#o'YS'p'P(`W(R'^(Q(T(eT(X'_(Y[%w#m#n#o'P'Y(`W'y'^(Q(T(eT(U'_(Y#]ZORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_n!_Q!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'aujQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aQ#cjQ#p}Q#r!RR#t!VulQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aQ#elR#hnunQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aupQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aurQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'autQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'auvQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aX%y#m#n#o'YuxQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'auzQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'ao!_Q!j!q!w!|#R$c$f$u$}%Q%X%[%c&ho!^Q!j!q!w!|#R$c$f$u$}%Q%X%[%c&hU$p!q$u&hV&X#y&Z'a]$j!q#y$u&Z&h'an!`Q!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au}Q!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aQ$W!jV&X#y&Z'aX$V!j#y&Z'an!aQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!PQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aQ$`!mV&X#y&Z'aX$Z!m#y&Z'aU$b!m$c$fV&X#y&Z'a]$]!m#y$c$f&Z'aU$o!q$u&hV&X#y&Z'a]$l!q#y$u&Z&h'an!bQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!RQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aQ&P#rR&Q#tT(P'^(QX'|'^'_(Q(YX(O'^'_(Q(YS$q!q$uV&X#y&Z'aZ$n!q#y$u&Z'an!cQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!TQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aS${!w!|V&X#y&Z'aZ$x!w!|#y&Z'a`$a!m!q!w!|#R$f%Q%[V&X#y&Z'ag$_!m!q!w!|#R#y$f%Q%[&Z'aU$|!w$}%QV&X#y&Z'a]$z!w#y$}%Q&Z'aV&U#y&Z'an!eQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!VQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aT(W'_(YS%b#R%cV&X#y&Z'aZ%a#R#y%c&Z'an!dQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!XQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'an!iQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hV&X#y&Z'au!ZQ!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'aU&X#y&Z'aR&}%iX&W#y%i&Z'au!]Q!j!q!w!|#R#y$c$f$u$}%Q%X%[%c&Z&h'a#]RORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_Q!kRR$X!l#]SORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_R!pSQ!oSQ!vTQ!yUQ#OVQ#TWQ$g!pQ$t!tS%R!z!{S%]#P#QQ%f#UQ&d$hS&p%S%TS&u%^%_Q'g&qR'j&vQ!nSS$d!o!pU&b$e$g$hS'b&c&dR(Z'c#]TORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_]!rT!t!v$t$v&iQ!uTS$s!t!vS&j$t$vR'd&i#]UORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_Q!zUQ#PVQ%T!{R%_#QQ!xUU%O!y!z!{W&n%P%R%S%TU'e&o&p&qS(['f'gR(i(]#]VORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_Q!}VU%Y#O#P#QW&s%Z%]%^%_U'h&t&u&vS(^'i'jR(j(_V%W!|%X%[V%V!|%X%[#]WORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_Q#SWS%d#T#US&x%e%fR'k&y#]XORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_o!hQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&ho!gQ!j!q!w!|#R$c$f$u$}%Q%X%[%c&hR%h#VR&|%gR&{%g#]YORTUVW^!l!o!p!t!v!y!z!{#O#P#Q#T#U$e$g$h$t$v%P%R%S%T%Z%]%^%_%e%f&c&d&i&o&p&q&t&u&v&y'c'f'g'i'j(](_R%j#WQ^OQ!lRQ!{UQ#QVQ#UW!O#X^!l!{#Q#U$e$h%P%S%Z%^%e&c&o&q&t&v&y'c'f'i(](_Q$e!oQ$h!pQ%P!yQ%S!zQ%Z#OQ%^#PQ%e#TQ&c$gQ&o%RQ&q%TQ&t%]Q&v%_Q&y%fQ'c&dQ'f&pQ'i&uQ(]'gR(_'jQ#^`R%p#^Q(a'qR(l(aQ%t#gS'T%t'tR't'UQ'Z%{Q'[%|Q']%}V'x'Z'[']Q#z!^R&[#zQ#y!^U&S#y&Z'aR&Z#zQ(Q'^R(d(QQ(T'^Q(e(QT(f(T(eQ(Y'_R(h(YQ#w!]R&R#wQ!tTU$r!t$v&iQ$v!vR&i$t#O]ORUVW^!l!o!p!y!z!{#O#P#Q#T#U$e$g$h%P%R%S%T%Z%]%^%_%e%f&c&d&o&p&q&t&u&v&y'c'f'g'i'j(](_]!rT!t!v$t$v&iQhPQ#ltR'R%rU`Pt%rQ#_aQ#`fQ#gnS#iprQ#mvQ#nxQ#ozQ#q!PQ#s!TQ#u!XQ%m#ZQ&^$ZQ&k$xQ'Q%qQ'S%sQ'U%uQ'W%yQ'^&PQ'_&QS'o'P(`Q'u'VQ'v'XQ(m(bQ(n(cR(o(gQ%{#mQ%|#nQ%}#oR'w'YV&Y#y&Z'aS(P'^(QT(X'_(YX(S'^(Q(T(e]!sT!t!v$t$v&i",
  nodeNames: "⚠ TagStart CommentText TagStart RawText LiquidTemplate Output OutputStart VariableName MemberExpression . PropertyName [ ] Quoted Number Boolean DropLiteral Null Range .. Filter FilterName : FilterArgs FilterArg KeyValuePair ArgumentName , OutputEnd Tag TagStart AssignTag TagName VariableDefinition = BlockTag TagName Label CycleTag TagName IncrementTag TagName DecrementTag TagName EchoTag TagName IncludeTag TagName with RenderTag TagName LayoutTag TagName LiquidTag TagName BreakTag TagName CaptureTag TagName EndCaptureTag TagName CaseTag TagName WhenTag TagName EndCaseTag TagName ContinueTag TagName ForTag TagName in ArgumentName reversed ArgumentName offset ArgumentName limit EndForTag TagName IfTag TagName ElsifTag TagName ElseTag TagName EndIfTag TagName InlineCommentTag TagName UnknownTagArg TableRowTag TagName ArgumentName cols EndTableRowTag TagName UnlessTag TagName RawTag TagName EndRawTag TagName UnknownTag TagName TagEnd CaptureBlock Tag Tag CaseBlock Tag Tag Tag Tag ForBlock Tag Tag Tag Tag IfBlock Tag Tag Tag UnlessBlock Tag Tag EndUnlessTag TagName TableRowBlock Tag Tag CommentBlock Tag CommentTag TagName Tag EndCommentTag TagName RawBlock Tag Tag Text",
  maxTerm: 211,
  nodeProps: [
    ["closedBy", -3,1,3,31,"TagEnd",7,"OutputEnd"],
    ["openedBy", 29,"OutputStart",106,"TagStart"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 12,
  tokenData: "!2T~RuOX#fXY(gYZ)lZ]#f]^*S^p#fpq(gqr#frs*nsu#fuv;gvw#fwx<{xyKoyzLkz|#f|}Mg}!ONc!O!P!#_!P!Q#f!Q![!%]![!]!(g!]!_#f!_!`!)c!`!c#f!c!}!*_!}#O!+v#O#P#f#P#Q!,r#Q#T#f#T#o!*_#o#p!-n#p#q!1X#q#r! c#r;'S#f;'S;=`(a<%lO#fT#mZ$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fP$eT$SPO#o$`#o#p$t#p;'S$`;'S;=`%W<%lO$`P$wTOu$`v#o$`#p;'S$`;'S;=`%W<%lO$`P%ZP;=`<%l$`T%c]$SPOY#fYZ$`Z]#f]^$`^#o#f#o#p&[#p#q#f#q#r$`#r;'S#f;'S;=`(a<%l~#f~O#f~~'oT&aZ!}SOY#fYZ$`Z]#f]^$`^u#fuv'Sv#o#f#o#p'o#p;'S#f;'S;=`(a<%lO#fS'VWOY'oZ]'o^#q'o#r;'S'o;'S;=`(Z<%l~'o~O'o~~'oS'tV!}SOY'oZ]'o^u'ouv'Sv;'S'o;'S;=`(Z<%lO'oS(^P;=`<%l'oT(dP;=`<%l#fV(p^$SP$cU!}SOX#fXY(gYZ$`Z]#f]^$`^p#fpq(gqu#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV)sT$SP$|UO#o$`#o#p$t#p;'S$`;'S;=`%W<%lO$`V*XV$SPOY$`YZ)lZ#o$`#o#p$t#p;'S$`;'S;=`%W<%lO$`V*u_$SP!}SOY*nYZ+tZ]*n]^+t^r*nrs1Vsu*nuv2Rv#O*n#O#P3]#P#o*n#o#p5k#p;'S*n;'S;=`;a<%lO*nR+yX$SPOr+trs,fs#O+t#O#P,|#P#o+t#o#p.b#p;'S+t;'S;=`1P<%lO+tR,mT$SP^QO#o$`#o#p$t#p;'S$`;'S;=`%W<%lO$`R-RX$SPOr+trs-ns#O+t#O#P,|#P#o+t#o#p.b#p;'S+t;'S;=`1P<%lO+tR-uX$SP^QOr+trs,fs#O+t#O#P,|#P#o+t#o#p.b#p;'S+t;'S;=`1P<%lO+tR.eZOr+trs,fsu+tuv/Wv#O+t#O#P,|#P#o+t#o#p/W#p;'S+t;'S;=`1P<%lO+tQ/ZVOr/Wrs/ps#O/W#O#P/u#P;'S/W;'S;=`0y<%lO/WQ/uO^QQ/xVOr/Wrs0_s#O/W#O#P/u#P;'S/W;'S;=`0y<%lO/WQ0dV^QOr/Wrs/ps#O/W#O#P/u#P;'S/W;'S;=`0y<%lO/WQ0|P;=`<%l/WR1SP;=`<%l+tV1`Z$SP^Q!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV2Wa$SPOY*nYZ+tZ]*n]^+t^r*nrs1Vs#O*n#O#P3]#P#o*n#o#p5k#p#q*n#q#r+t#r;'S*n;'S;=`;a<%l~*n~O*n~~'oV3d_$SP!}SOY*nYZ+tZ]*n]^+t^r*nrs4csu*nuv2Rv#O*n#O#P3]#P#o*n#o#p5k#p;'S*n;'S;=`;a<%lO*nV4l_$SP^Q!}SOY*nYZ+tZ]*n]^+t^r*nrs1Vsu*nuv2Rv#O*n#O#P3]#P#o*n#o#p5k#p;'S*n;'S;=`;a<%lO*nV5p_!}SOY*nYZ+tZ]*n]^+t^r*nrs1Vsu*nuv6ov#O*n#O#P3]#P#o*n#o#p7q#p;'S*n;'S;=`;a<%lO*nU6r_OY7qYZ/WZ]7q]^/W^r7qrs8os#O7q#O#P9]#P#q7q#q#r/W#r;'S7q;'S;=`;Z<%l~7q~O7q~~'oU7v]!}SOY7qYZ/WZ]7q]^/W^r7qrs8osu7quv6ov#O7q#O#P9]#P;'S7q;'S;=`;Z<%lO7qU8vV^Q!}SOY'oZ]'o^u'ouv'Sv;'S'o;'S;=`(Z<%lO'oU9b]!}SOY7qYZ/WZ]7q]^/W^r7qrs:Zsu7quv6ov#O7q#O#P9]#P;'S7q;'S;=`;Z<%lO7qU:b]^Q!}SOY7qYZ/WZ]7q]^/W^r7qrs8osu7quv6ov#O7q#O#P9]#P;'S7q;'S;=`;Z<%lO7qU;^P;=`<%l7qV;dP;=`<%l*nV;l]$SPOY#fYZ$`Z]#f]^$`^#o#f#o#p&[#p#q#f#q#r<e#r;'S#f;'S;=`(a<%l~#f~O#f~~'oV<lT$SP#^UO#o$`#o#p$t#p;'S$`;'S;=`%W<%lO$`V=S_$SP!}SOY<{YZ>RZ]<{]^>R^u<{uvBwvw<{wx1Vx#O<{#O#PDR#P#o<{#o#pFa#p;'S<{;'S;=`Ki<%lO<{R>WX$SPOw>Rwx,fx#O>R#O#P>s#P#o>R#o#p@X#p;'S>R;'S;=`Bq<%lO>RR>xX$SPOw>Rwx?ex#O>R#O#P>s#P#o>R#o#p@X#p;'S>R;'S;=`Bq<%lO>RR?lX$SP^QOw>Rwx,fx#O>R#O#P>s#P#o>R#o#p@X#p;'S>R;'S;=`Bq<%lO>RR@[ZOu>Ruv@}vw>Rwx,fx#O>R#O#P>s#P#o>R#o#p@}#p;'S>R;'S;=`Bq<%lO>RQAQVOw@}wx/px#O@}#O#PAg#P;'S@};'S;=`Bk<%lO@}QAjVOw@}wxBPx#O@}#O#PAg#P;'S@};'S;=`Bk<%lO@}QBUV^QOw@}wx/px#O@}#O#PAg#P;'S@};'S;=`Bk<%lO@}QBnP;=`<%l@}RBtP;=`<%l>RVB|a$SPOY<{YZ>RZ]<{]^>R^w<{wx1Vx#O<{#O#PDR#P#o<{#o#pFa#p#q<{#q#r>R#r;'S<{;'S;=`Ki<%l~<{~O<{~~'oVDY_$SP!}SOY<{YZ>RZ]<{]^>R^u<{uvBwvw<{wxEXx#O<{#O#PDR#P#o<{#o#pFa#p;'S<{;'S;=`Ki<%lO<{VEb_$SP^Q!}SOY<{YZ>RZ]<{]^>R^u<{uvBwvw<{wx1Vx#O<{#O#PDR#P#o<{#o#pFa#p;'S<{;'S;=`Ki<%lO<{VFf_!}SOY<{YZ>RZ]<{]^>R^u<{uvGevw<{wx1Vx#O<{#O#PDR#P#o<{#o#pHg#p;'S<{;'S;=`Ki<%lO<{UGh_OYHgYZ@}Z]Hg]^@}^wHgwx8ox#OHg#O#PIe#P#qHg#q#r@}#r;'SHg;'S;=`Kc<%l~Hg~OHg~~'oUHl]!}SOYHgYZ@}Z]Hg]^@}^uHguvGevwHgwx8ox#OHg#O#PIe#P;'SHg;'S;=`Kc<%lOHgUIj]!}SOYHgYZ@}Z]Hg]^@}^uHguvGevwHgwxJcx#OHg#O#PIe#P;'SHg;'S;=`Kc<%lOHgUJj]^Q!}SOYHgYZ@}Z]Hg]^@}^uHguvGevwHgwx8ox#OHg#O#PIe#P;'SHg;'S;=`Kc<%lOHgUKfP;=`<%lHgVKlP;=`<%l<{VKxZ$lQ$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fVLtZ$mQ$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fVMpZlQ$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fVNj]$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv;gv#o#f#o#p&[#p#q#f#q#r! c#r;'S#f;'S;=`(a<%lO#fV! j]$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p#q#f#q#r!!c#r;'S#f;'S;=`(a<%lO#fV!!lZ$SPmQ!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!#h]$SPYQ!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v!O#f!O!P!$a!P#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!$jZ$SPdQ!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!%f_$SP_Q!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v!O#f!O!P!&e!P!Q#f!Q![!%]![#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!&l]$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v!Q#f!Q![!'e![#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!'n]$SP_Q!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v!Q#f!Q![!'e![#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!(pZ$SPgQ!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!)lZ$SPsQ!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!*hd$SP$gQ!}SOY#fYZ$`Z]#f]^$`^s#fst!*_tu#fuv%^v!Q#f!Q![!*_![!c#f!c!}!*_!}#R#f#R#S!*_#S#T#f#T#o!*_#o#p&[#p;'S#f;'S;=`(a<%lO#fV!,PZ$SP[Q!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#fV!,{Z$SP]Q!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#f~!-sZ!}SOY#fYZ$`Z]#f]^$`^u#fuv!.fv#o#f#o#p!/w#p;'S#f;'S;=`(a<%lO#f~!.kYo~OY'oZ]'o^}'o}!O!/Z!O#q'o#r;'S'o;'S;=`(Z<%l~'o~O'o~~'o~!/bVo~!}SOY'oZ]'o^u'ouv'Sv;'S'o;'S;=`(Z<%lO'o~!0OXV~!}SOY'oZ]'o^u'ouv'Sv}'o}!O!0k!O;'S'o;'S;=`(Z<%lO'o~!0rVV~!}SOY'oZ]'o^u'ouv'Sv;'S'o;'S;=`(Z<%lO'oV!1bZ$nQ$SP!}SOY#fYZ$`Z]#f]^$`^u#fuv%^v#o#f#o#p&[#p;'S#f;'S;=`(a<%lO#f",
  tokenizers: [comment, raw, 0, 1, 2],
  topRules: {"LiquidTemplate":[0,5]},
  specialized: [{term: 161, get: (value) => spec_identifier[value] || -1}],
  tokenPrec: 1571
});

const highlight = styleTags({
    "TagName/...": tags.tagName,
    "FilterName/...": tags.modifier,
    Literal: tags.literal,
    Identifier: tags.name,
    "in with": tags.operatorKeyword,
    "ArgumentName/...": tags.definition(tags.propertyName),
    "VariableDefinition/...": tags.variableName,
    "VariableName/...": tags.variableName,
    Quoted: tags.string,
    Boolean: tags.bool,
    DropLiteral: tags.bool,
    Null: tags.null,
    Number: tags.number,
    "[ ]": tags.squareBracket,
    "{{ }}": tags.squareBracket,
    "{% %}": tags.squareBracket,
    "| , :": tags.punctuation,
    "..": tags.operator
});

const TagNames = [
    "assign", "increment", "decrement", "capture",
    "cycle", "echo", "liquid",
    "if", "unless", "case",
    "for", "tablerow",
    "include", "layout", "render", "block",
    "#", "raw", "comment",
];
const FilterNames = [
    'escape', 'escape_once', 'newline_to_br', 'strip_html',
    'abs', 'at_least', 'at_most', 'ceil', 'divided_by', 'floor', 'minus', 'modulo', 'times', 'round', 'plus',
    'url_decode', 'url_encode',
    'join', 'last', 'first', 'reverse', 'sort', 'sort_natural', 'size', 'map', 'compact', 'concat', 'push', 'slice', 'where', 'uniq', 'sample',
    'date',
    'append', 'prepend', 'lstrip', 'downcase', 'upcase', 'remove', 'remove_first', 'remove_last', 'rstrip', 'split', 'strip', 'strip_newlines', 'capitalize', 'replace', 'replace_first', 'replace_last', 'truncate', 'truncatewords',
    'json', 'raw', 'default'
];
const BuiltinValues = ["nil", "null", "false", "true", "empty", "blank"];
function tagNameCompletions(tagNames) {
    return [
        ifTagNameCompletion(["TagName"], tagNames, "class"),
        ifTagNameCompletion(["CaptureBlock"], ["endcapture"], "class"),
        ifTagNameCompletion(["ForBlock"], ["break", "continue", "endfor"], "class"),
        ifTagNameCompletion(["IfBlock"], ["elsif", "else", "endif",], "class"),
        ifTagNameCompletion(["UnlessBlock"], ["elsif", "else", "endunless",], "class"),
        ifTagNameCompletion(["CaseBlock"], ["when", "endcase",], "class"),
        ifTagNameCompletion(["TableRowBlock"], ["endtablerow",], "class"),
        ifTagNameCompletion(["CommentBlock"], ["endcomment",], "class"),
        ifTagNameCompletion(["RawBlock"], ["endraw",], "class"),
    ];
}
const argumentCompletions = [
    ifCompletion(["ForTag"], ["reversed", "limit", "offset"], "property"),
    ifCompletion(["IncludeTag", "RenderTag", "LayoutTag"], ["with"], "keyword"),
    ifCompletion(["TableRowTag"], ["offset", "limit", "cols"], "keyword"),
];
function ifTagNameCompletion(nodes, tagNames, type) {
    return ifIn(nodes, completeFromList(tagNames.map(tagName => ({ label: tagName, type, apply: (view, completion, from, to) => {
            const appendTagEnd = isNothingAfter(view, to) && !inLiquidTag(view, from);
            const insert = appendTagEnd ? `${tagName} %}` : tagName;
            view.dispatch(view.state.update(Object.assign(Object.assign({}, insertCompletionText(view.state, insert, from, to)), { annotations: pickedCompletion.of(completion) })));
            if (appendTagEnd) {
                const cursor = view.state.selection.main;
                view.dispatch({ selection: view.moveByGroup(cursor, false) });
            }
        } }))));
}
function ifCompletion(nodes, tagNames, type) {
    return ifIn(nodes, completeFromList(tagNames.map(tagName => ({ label: tagName, type }))));
}
function inLiquidTag(view, begin) {
    let str = '';
    for (let iter = view.state.doc.iterRange(begin, 0); !iter.next().done;) {
        str = iter.value + str;
        if (str.slice(0, 2) === "{%") {
            return str.match(/^{%-?\s*liquid\s+/i);
        }
    }
    return false;
}
function isNothingAfter(view, begin) {
    for (let iter = view.state.doc.iterRange(begin); !iter.next().done;) {
        if (["\t", " "].includes(iter.value))
            continue;
        else if (iter.lineBreak)
            return true;
        else
            return false;
    }
    return true;
}
function liquidCompletions({ tagNames = [], filterNames = [], variableNames = [] } = {}) {
    variableNames = variableNames.map(name => /^[a-zA-Z_]\w*$/.test(name) ? name : `["${name}"]`);
    return [
        ...tagNameCompletions([...TagNames, ...tagNames]),
        ...argumentCompletions,
        ifCompletion(["FilterName"], [...FilterNames, ...filterNames], "function"),
        ifCompletion(["VariableName"], BuiltinValues, "keyword"),
        ifCompletion(["VariableName"], variableNames, "variable"),
    ];
}

// "{" will be used to begin tag or output, not close with "}"
const closeBrackets = { brackets: "(['\"" };
const liquidLanguage = LRLanguage.define({
    name: "liquid",
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Tag: delimitedIndent({ closing: "%}" }),
                "UnlessTag ForTag TablerowTag CaptureTag": directiveIndent(/^\s*(\{%-?\s*)?end\w/),
                IfTag: directiveIndent(/^\s*(\{%-?\s*)?(endif|else|elsif)\b/),
                CaseTag: directiveIndent(/^\s*(\{%-?\s*)?(endcase|when)\b/),
            }),
            foldNodeProp.add({
                "IfBlock UnlessBlock ForBlock TablerowBlock CaptureBlock CaseBlock RawBlock CommentBlock": foldInside
            }),
            highlight
        ]
    }),
    languageData: {
        closeBrackets,
        commentTokens: { line: "#", block: { open: "{% comment %}", close: "{% endcomment %}" } },
        indentOnInput: /^\s*{%-?\s*(?:end|elsif|else|when|)$/
    }
});
function directiveIndent(except) {
    return (context) => {
        let back = except.test(context.textAfter);
        return context.lineIndent(context.node.from) + (back ? 0 : context.unit);
    };
}
const liquidHTMLLanguage = liquidLanguage.configure({
    wrap: parseMixed(node => node.type.isTop ? {
        parser: htmlLanguage.parser,
        overlay: n => n.name == "Text" || n.name == "RawText"
    } : null)
}, "liquid");
function liquidCompletionExts(options) {
    return liquidCompletions(options).map(autocomplete => liquidHTMLLanguage.data.of({ autocomplete }));
}
function Liquid(options) {
    return new LanguageSupport(liquidLanguage, liquidCompletionExts(options));
}
function LiquidHTML(options) {
    return new LanguageSupport(liquidHTMLLanguage, [
        ...liquidCompletionExts(options),
        htmlLanguage.data.of({ closeBrackets }),
        html().support,
    ]);
}

export { Liquid, LiquidHTML, liquidHTMLLanguage, liquidLanguage };
